package task1;

public class ParkingLot {

	private ParkingSpace[] parkingSpaces;
	
	public ParkingLot(int capacity) {
		if( capacity <= 0 ) {
			capacity = 40;
			System.out.println("Error! Capacity has to be a positive number");
		}
		parkingSpaces = new ParkingSpace[capacity];
		
		for (int i = 0; i < parkingSpaces.length; i++) {
			parkingSpaces[i] = new ParkingSpace();
			parkingSpaces[i].setFree(true);
		}
	}
	
	public boolean isThereAFreeSpace() {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if (parkingSpaces[i].isFree()) return true;
		}
		return false;
	}
	
	public int findAFreeSpace() {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if (parkingSpaces[i].isFree()) return i;
		}
		return -1;
	}
	
	public void parkVehicle(String regNum) {
		int freeSpace = findAFreeSpace();
		if (freeSpace >= 0) {
			parkingSpaces[freeSpace].setRegistrationNumber(regNum);
			parkingSpaces[freeSpace].setFree(false);
		} else
			System.out.println("Error! No space left");
	}
	
	public boolean isVehicleParked(String regNum) {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if ( !parkingSpaces[i].isFree() &&
					parkingSpaces[i].getRegistrationNumber().equals(regNum))
				return true;
		}
		return false;
	}
	
	public int findVehicle(String regNum) {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if ( !parkingSpaces[i].isFree() &&
					parkingSpaces[i].getRegistrationNumber().equals(regNum))
				return i;
		}
		return -1;
	}
	
	
	public void removeVehicle(String regNum) {
		int vIndex = findVehicle(regNum);
		if( vIndex >= 0 ) {
			parkingSpaces[vIndex].setFree(true);
			parkingSpaces[vIndex].setRegistrationNumber(null);
		} else
			System.out.println("Error! The vehicle is not parked at this lot");
	}
	
}



