package task1;

public class ParkingLot {
	
	private ParkingSpace[] parkingSpaces;
	
	public ParkingLot(int capacity) {
		if ( capacity <= 0 ) {
			capacity = 40;
			System.out.println("Error! The capacity has to be a positive number");
		}
		
		parkingSpaces = new ParkingSpace[capacity];
		
		for (int i = 0; i < parkingSpaces.length; i++) {
			parkingSpaces[i] = new ParkingSpace();
			parkingSpaces[i].setFree(true);
		}
	}
	
	public boolean isThereAFreeSpace() {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if( parkingSpaces[i].isFree() ) return true;
		}
		return false;
	}
	
	public int findFreeSpace() {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if( parkingSpaces[i].isFree() ) return i;
		}
		return -1;
	}
	
	public void parkVehicle(String regNum) {
		int index = findFreeSpace();
		if (index < 0) 
			System.out.println("Error! The parking lot is already full");
		else {
			parkingSpaces[index].setFree(false);
			parkingSpaces[index].setRegistrationNumber(regNum);
		}
	}
	
	public boolean isVehicleAtTheLot(String regNum) {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if ( !parkingSpaces[i].isFree() &&
					parkingSpaces[i].getRegistrationNumber().equals(regNum))
				return true;
		}
		return false;
	}
	
	public void removeVehicle(String regNum) {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if ( !parkingSpaces[i].isFree() &&
					parkingSpaces[i].getRegistrationNumber().equals(regNum) ) {
				parkingSpaces[i].setFree(true);
				parkingSpaces[i].setRegistrationNumber(null);
				return;
			}
		}
		System.out.println("Error! The vehicle is not parked here");
	}
	
	public int findVehicleAtTheLot(String regNum) {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if ( !parkingSpaces[i].isFree() &&
					parkingSpaces[i].getRegistrationNumber().equals(regNum))
				return i;
		}
		return -1;
	}
	
	public void removeVehicle2(String regNum) {
		int vIndex = findVehicleAtTheLot(regNum);
		if ( vIndex >= 0 ) {
			parkingSpaces[vIndex].setFree(true);
			parkingSpaces[vIndex].setRegistrationNumber(null);
		} else
			System.out.println("Error! The vehicle is not parked here");
	}

}




